Multiple Y-Axes (Aligned Zero) in JavaScript

Using ApexCharts with JavaScript

This Multiple Y-Axes (Aligned Zero) example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
var options = {
  series: [
    {
      name: 'Profit',
      type: 'column',
      data: [5, 12, -8, 14, -3, 9, -2, 6],
    },
    {
      name: 'Units Sold',
      type: 'column',
      data: [1.2, 2.1, 1.8, 2.7, 2.0, 2.4, 1.9, 2.6],
    },
    {
      name: 'Index',
      type: 'line',
      data: [25, 27, 26, 29, 28, 29, 30, 30],
    },
  ],
  chart: {
    height: 350,
    type: 'line',
    stacked: false,
  },
  stroke: {
    width: [0, 0, 4],
  },
  title: {
    text: 'Multiple Y-Axes With Aligned Zero',
    align: 'left',
  },
  xaxis: {
    categories: ['Q1', 'Q2', 'Q3', 'Q4', 'Q5', 'Q6', 'Q7', 'Q8'],
  },
  yaxis: [
    {
      seriesName: 'Profit',
      alignZero: true,
      axisTicks: { show: true },
      axisBorder: { show: true, color: '#008FFB' },
      labels: { style: { colors: '#008FFB' } },
      title: { text: 'Profit (mixed +/-)', style: { color: '#008FFB' } },
    },
    {
      seriesName: 'Units Sold',
      alignZero: true,
      opposite: true,
      axisTicks: { show: true },
      axisBorder: { show: true, color: '#00E396' },
      labels: { style: { colors: '#00E396' } },
      title: { text: 'Units (positive only)', style: { color: '#00E396' } },
    },
    {
      seriesName: 'Index',
      alignZero: true,
      opposite: true,
      axisTicks: { show: true },
      axisBorder: { show: true, color: '#FEB019' },
      labels: { style: { colors: '#FEB019' } },
      title: { text: 'Index', style: { color: '#FEB019' } },
    },
  ],
  tooltip: { shared: true, intersect: false },
  legend: { horizontalAlign: 'left' },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Multiple Y-Axes (Aligned Zero) in Vue

Using ApexCharts with Vue

This Multiple Y-Axes (Aligned Zero) example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="line"
        height="350"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          name: 'Profit',
          type: 'column',
          data: [5, 12, -8, 14, -3, 9, -2, 6],
        },
        {
          name: 'Units Sold',
          type: 'column',
          data: [1.2, 2.1, 1.8, 2.7, 2.0, 2.4, 1.9, 2.6],
        },
        {
          name: 'Index',
          type: 'line',
          data: [25, 27, 26, 29, 28, 29, 30, 30],
        },
      ],
      chartOptions: {
        chart: {
          height: 350,
          type: 'line',
          stacked: false,
        },
        stroke: {
          width: [0, 0, 4],
        },
        title: {
          text: 'Multiple Y-Axes With Aligned Zero',
          align: 'left',
        },
        xaxis: {
          categories: ['Q1', 'Q2', 'Q3', 'Q4', 'Q5', 'Q6', 'Q7', 'Q8'],
        },
        yaxis: [
          {
            seriesName: 'Profit',
            alignZero: true,
            axisTicks: { show: true },
            axisBorder: { show: true, color: '#008FFB' },
            labels: { style: { colors: '#008FFB' } },
            title: { text: 'Profit (mixed +/-)', style: { color: '#008FFB' } },
          },
          {
            seriesName: 'Units Sold',
            alignZero: true,
            opposite: true,
            axisTicks: { show: true },
            axisBorder: { show: true, color: '#00E396' },
            labels: { style: { colors: '#00E396' } },
            title: {
              text: 'Units (positive only)',
              style: { color: '#00E396' },
            },
          },
          {
            seriesName: 'Index',
            alignZero: true,
            opposite: true,
            axisTicks: { show: true },
            axisBorder: { show: true, color: '#FEB019' },
            labels: { style: { colors: '#FEB019' } },
            title: { text: 'Index', style: { color: '#FEB019' } },
          },
        ],
        tooltip: { shared: true, intersect: false },
        legend: { horizontalAlign: 'left' },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 650px;
  margin: 35px auto;
}
</style>

Multiple Y-Axes (Aligned Zero) in React

Using ApexCharts with React

This Multiple Y-Axes (Aligned Zero) example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: 'Profit',
        type: 'column',
        data: [5, 12, -8, 14, -3, 9, -2, 6],
      },
      {
        name: 'Units Sold',
        type: 'column',
        data: [1.2, 2.1, 1.8, 2.7, 2.0, 2.4, 1.9, 2.6],
      },
      {
        name: 'Index',
        type: 'line',
        data: [25, 27, 26, 29, 28, 29, 30, 30],
      },
    ],
    options: {
      chart: {
        height: 350,
        type: 'line',
        stacked: false,
      },
      stroke: {
        width: [0, 0, 4],
      },
      title: {
        text: 'Multiple Y-Axes With Aligned Zero',
        align: 'left',
      },
      xaxis: {
        categories: ['Q1', 'Q2', 'Q3', 'Q4', 'Q5', 'Q6', 'Q7', 'Q8'],
      },
      yaxis: [
        {
          seriesName: 'Profit',
          alignZero: true,
          axisTicks: { show: true },
          axisBorder: { show: true, color: '#008FFB' },
          labels: { style: { colors: '#008FFB' } },
          title: { text: 'Profit (mixed +/-)', style: { color: '#008FFB' } },
        },
        {
          seriesName: 'Units Sold',
          alignZero: true,
          opposite: true,
          axisTicks: { show: true },
          axisBorder: { show: true, color: '#00E396' },
          labels: { style: { colors: '#00E396' } },
          title: { text: 'Units (positive only)', style: { color: '#00E396' } },
        },
        {
          seriesName: 'Index',
          alignZero: true,
          opposite: true,
          axisTicks: { show: true },
          axisBorder: { show: true, color: '#FEB019' },
          labels: { style: { colors: '#FEB019' } },
          title: { text: 'Index', style: { color: '#FEB019' } },
        },
      ],
      tooltip: { shared: true, intersect: false },
      legend: { horizontalAlign: 'left' },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="line"
          height={350}
        />
      </div>
    </div>
  )
}

export default ApexChart

Multiple Y-Axes (Aligned Zero) in Angular

Using ApexCharts with Angular

This Multiple Y-Axes (Aligned Zero) example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: 'Profit',
              type: 'column',
              data: [5, 12, -8, 14, -3, 9, -2, 6],
            },
            {
              name: 'Units Sold',
              type: 'column',
              data: [1.2, 2.1, 1.8, 2.7, 2.0, 2.4, 1.9, 2.6],
            },
            {
              name: 'Index',
              type: 'line',
              data: [25, 27, 26, 29, 28, 29, 30, 30],
            },
          ],
          chart: {
            height: 350,
            type: 'line',
            stacked: false,
          },
          stroke: {
            width: [0, 0, 4],
          },
          title: {
            text: 'Multiple Y-Axes With Aligned Zero',
            align: 'left',
          },
          xaxis: {
            categories: ['Q1', 'Q2', 'Q3', 'Q4', 'Q5', 'Q6', 'Q7', 'Q8'],
          },
          yaxis: [
            {
              seriesName: 'Profit',
              alignZero: true,
              axisTicks: { show: true },
              axisBorder: { show: true, color: '#008FFB' },
              labels: { style: { colors: '#008FFB' } },
              title: { text: 'Profit (mixed +/-)', style: { color: '#008FFB' } },
            },
            {
              seriesName: 'Units Sold',
              alignZero: true,
              opposite: true,
              axisTicks: { show: true },
              axisBorder: { show: true, color: '#00E396' },
              labels: { style: { colors: '#00E396' } },
              title: { text: 'Units (positive only)', style: { color: '#00E396' } },
            },
            {
              seriesName: 'Index',
              alignZero: true,
              opposite: true,
              axisTicks: { show: true },
              axisBorder: { show: true, color: '#FEB019' },
              labels: { style: { colors: '#FEB019' } },
              title: { text: 'Index', style: { color: '#FEB019' } },
            },
          ],
          tooltip: { shared: true, intersect: false },
          legend: { horizontalAlign: 'left' },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}